Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.log4jdbc
Class CallableStatementSpy

    java.lang.Object
      net.sf.log4jdbc.StatementSpy
          net.sf.log4jdbc.PreparedStatementSpy
              net.sf.log4jdbc.CallableStatementSpy

All Implemented Interfaces:
  CallableStatement, PreparedStatement, Spy, Statement

public class CallableStatementSpy
extends PreparedStatementSpy
implements CallableStatement

Wraps a CallableStatement and reports method calls, returns and exceptions.

Author:
  Arthur Blake

Field Summary

Fields inherited from class net.sf.log4jdbc.PreparedStatementSpy
`argTrace, rdbmsSpecifics, realPreparedStatement`

Fields inherited from class net.sf.log4jdbc.StatementSpy
`connectionSpy, currentBatch, realStatement`

Fields inherited from interface java.sql.Statement
`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

Constructor Summary
`CallableStatementSpy(String sql, ConnectionSpy connectionSpy, CallableStatement realCallableStatement)` Create a CallableStatementSpy to spy upon a CallableStatement.

Method Summary
`Array` | `getArray(int i)` Retrieves the value of the designated JDBC `ARRAY` parameter as an `Array` object in the Java programming language.
`Array` | `getArray(String parameterName)` Retrieves the value of a JDBC `ARRAY` parameter as an `Array` object in the Java programming language.
`BigDecimal` | `getBigDecimal(int parameterIndex)` Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.
`BigDecimal` | `getBigDecimal(int parameterIndex, int scale)` Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with scale digits to the right of the decimal point.
`BigDecimal` | `getBigDecimal(String parameterName)` Retrieves the value of a JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.
`Blob` | `getBlob(int i)` Retrieves the value of the designated JDBC `BLOB` parameter as a `Blob` object in the Java programming language.
`Blob` | `getBlob(String parameterName)` Retrieves the value of a JDBC `BLOB` parameter as a `Blob` object in the Java programming language.
`boolean` | `getBoolean(int parameterIndex)` Retrieves the value of the designated JDBC `BIT` parameter as a `boolean` in the Java programming language.
`boolean` | `getBoolean(String parameterName)` Retrieves the value of a JDBC `BIT` parameter as a `boolean` in the Java programming language.
`byte` | `getByte(int parameterIndex)` Retrieves the value of the designated JDBC `TINYINT` parameter as a `byte` in the Java programming language.
`byte` | `getByte(String parameterName)` Retrieves the value of a JDBC `TINYINT` parameter as a `byte` in the Java programming language.
`byte[]` | `getBytes(int parameterIndex)` Retrieves the value of the designated JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.
`byte[]` | `getBytes(String parameterName)` Retrieves the value of a JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.
`String` | `getClassType()` Get the type of class being spied upon.
`Clob` | `getClob(int i)` Retrieves the value of the designated JDBC `CLOB` parameter as a `Clob` object in the Java programming language.
`Clob` | `getClob(String parameterName)` Retrieves the value of a JDBC `CLOB` parameter as a `Clob` object in the Java programming language.
`Date` | `getDate(int parameterIndex)` Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object.
`Date` | `getDate(int parameterIndex, Calendar cal)` Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date.
`Date` | `getDate(String parameterName)` Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object.
`Date` | `getDate(String parameterName, Calendar cal)` Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date.
`double` | `getDouble(int parameterIndex)` Retrieves the value of the designated JDBC `DOUBLE` parameter as a `double` in the Java programming language.
`double` | `getDouble(String parameterName)` Retrieves the value of a JDBC `DOUBLE` parameter as a `double` in the Java programming language.
`float` | `getFloat(int parameterIndex)` Retrieves the value of the designated JDBC `FLOAT` parameter as a `float` in the Java programming language.
`float` | `getFloat(String parameterName)` Retrieves the value of a JDBC `FLOAT` parameter as a `float` in the Java programming language.
`int` | `getInt(int parameterIndex)` Retrieves the value of the designated JDBC `INTEGER` parameter as an `int` in the Java programming language.
`int` | `getInt(String parameterName)` Retrieves the value of a JDBC `INTEGER` parameter as an `int` in the Java programming language.
`long` | `getLong(int parameterIndex)` Retrieves the value of the designated JDBC `BIGINT` parameter as a `long` in the Java programming language.
`long` | `getLong(String parameterName)` Retrieves the value of a JDBC `BIGINT` parameter as a `long` in the Java programming language.
`Object` | `getObject(int parameterIndex)` Retrieves the value of the designated parameter as an `Object` in the Java programming language.
`Object` | `getObject(int i, Map map)` Returns an object representing the value of OUT parameter `i` and uses `map` for the custom mapping of the parameter value.
`Object` | `getObject(String parameterName)` Retrieves the value of a parameter as an `Object` in the Java programming language.
`Object` | `getObject(String parameterName, Map map)` Returns an object representing the value of OUT parameter `i` and uses `map` for the custom mapping of the parameter value.
`Ref` | `getRef(int i)` Retrieves the value of the designated JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.
`Ref` | `getRef(String parameterName)` Retrieves the value of a JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.
`short` | `getShort(int parameterIndex)` Retrieves the value of the designated JDBC `SMALLINT` parameter as a `short` in the Java programming language.
`short` | `getShort(String parameterName)` Retrieves the value of a JDBC `SMALLINT` parameter as a `short` in the Java programming language.
`String` | `getString(int parameterIndex)` Retrieves the value of the designated JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.
`String` | `getString(String parameterName)` Retrieves the value of a JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.
`Time` | `getTime(int parameterIndex)` Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object.
`Time` | `getTime(int parameterIndex, Calendar cal)` Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time.
`Time` | `getTime(String parameterName)` Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object.
`Time` | `getTime(String parameterName, Calendar cal)` Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time.
`Timestamp` | `getTimestamp(int parameterIndex)` Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.
`Timestamp` | `getTimestamp(int parameterIndex, Calendar cal)` Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object.
`Timestamp` | `getTimestamp(String parameterName)` Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.
`Timestamp` | `getTimestamp(String parameterName, Calendar cal)` Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object.
`URL` | `getURL(int parameterIndex)` Retrieves the value of the designated JDBC `DATALINK` parameter as a `java.net.URL` object.
`URL` | `getURL(String parameterName)` Retrieves the value of a JDBC `DATALINK` parameter as a `java.net.URL` object.
`void` | `registerOutParameter(int parameterIndex, int sqlType)` Registers the OUT parameter in ordinal position `parameterIndex` to the JDBC type `sqlType`.
`void` | `registerOutParameter(int parameterIndex, int sqlType, int scale)` Registers the parameter in ordinal position `parameterIndex` to be of JDBC type `sqlType`.
`void` | `registerOutParameter(int paramIndex, int sqlType, String typeName)` Registers the designated output parameter.
`void` | `registerOutParameter(String parameterName, int sqlType)` Registers the OUT parameter named `parameterName` to the JDBC type `sqlType`.
`void` | `registerOutParameter(String parameterName, int sqlType, int scale)` Registers the parameter named `parameterName` to be of JDBC type `sqlType`.
`void` | `registerOutParameter(String parameterName, int sqlType, String typeName)` Registers the designated output parameter.
`protected void` | `reportAllReturns(String methodCall, String msg)` Report (for logging) that a method returned.
`void` | `setAsciiStream(String parameterName, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBigDecimal(String parameterName, BigDecimal x)` Sets the designated parameter to the given `java.math.BigDecimal` value.
`void` | `setBinaryStream(String parameterName, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBoolean(String parameterName, boolean x)` Sets the designated parameter to the given Java `boolean` value.
`void` | `setByte(String parameterName, byte x)` Sets the designated parameter to the given Java `byte` value.
`void` | `setBytes(String parameterName, byte[] x)` Sets the designated parameter to the given Java array of bytes.
`void` | `setCharacterStream(String parameterName, Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` | `setDate(String parameterName, Date x)` Sets the designated parameter to the given `java.sql.Date` value.
`void` | `setDate(String parameterName, Date x, Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` | `setDouble(String parameterName, double x)` Sets the designated parameter to the given Java `double` value.
`void` | `setFloat(String parameterName, float x)` Sets the designated parameter to the given Java `float` value.
`void` | `setInt(String parameterName, int x)` Sets the designated parameter to the given Java `int` value.
`void` | `setLong(String parameterName, long x)` Sets the designated parameter to the given Java `long` value.
`void` | `setNull(String parameterName, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` | `setNull(String parameterName, int sqlType, String typeName)` Sets the designated parameter to SQL `NULL`.
`void` | `setObject(String parameterName, Object x)` Sets the value of the designated parameter with the given object.
`void` | `setObject(String parameterName, Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` | `setObject(String parameterName, Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
`void` | `setShort(String parameterName, short x)` Sets the designated parameter to the given Java `short` value.
`void` | `setString(String parameterName, String x)` Sets the designated parameter to the given Java `String` value.
`void` | `setTime(String parameterName, Time x)` Sets the designated parameter to the given `java.sql.Time` value.
`void` | `setTime(String parameterName, Time x, Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` | `setTimestamp(String parameterName, Timestamp x)` Sets the designated parameter to the given `java.sql.Timestamp` value.
`void` | `setTimestamp(String parameterName, Timestamp x, Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` | `setURL(String parameterName, URL val)` Sets the designated parameter to the given `java.net.URL` object.
`boolean` | `wasNull()` Retrieves whether the last OUT parameter read had the value of SQL `NULL`.

Methods inherited from class net.sf.log4jdbc.PreparedStatementSpy
`addBatch, argTraceSet, clearParameters, dumpedSql, execute, executeQuery, executeUpdate, getMetaData, getParameterMetaData, setArray, setAsciiStream, setBigDecimal, setBinaryStream, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNull, setNull, setObject, setObject, setObject, setRef, setShort, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

Methods inherited from class net.sf.log4jdbc.StatementSpy
`addBatch, cancel, clearBatch, clearWarnings, close, execute, execute, execute, execute, executeBatch, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getConnectionNumber, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, reportException, reportException, reportException, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportSql, reportSqlTiming, reportStatementSql, reportStatementSqlTiming, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.PreparedStatement
`addBatch, clearParameters, execute, executeQuery, executeUpdate, getMetaData, getParameterMetaData, setArray, setAsciiStream, setBigDecimal, setBinaryStream, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNull, setNull, setObject, setObject, setObject, setRef, setShort, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

Methods inherited from interface java.sql.Statement
`addBatch, cancel, clearBatch, clearWarnings, close, execute, execute, execute, execute, executeBatch, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Constructor Detail

### CallableStatementSpy

    public CallableStatementSpy(String sql,
                                ConnectionSpy connectionSpy,
                                CallableStatement realCallableStatement)

  Create a CallableStatementSpy to spy upon a CallableStatement.

Parameters:
  `sql` - The SQL used for this CallableStatement
  `connectionSpy` - The ConnectionSpy which produced this CallableStatementSpy
  `realCallableStatement` - The real CallableStatement that is being spied upon

Method Detail

### reportAllReturns

    protected void reportAllReturns(String methodCall,
                                    String msg)

  Description copied from class: `StatementSpy`
  Report (for logging) that a method returned. All the other reportReturn methods are conveniance methods that call this method.

  Overrides:
    `reportAllReturns` in class `PreparedStatementSpy`

### getClassType

    public String getClassType()

  Description copied from interface: `Spy`
  Get the type of class being spied upon. For example, "Statement", "ResultSet", etc.

  Specified by:
    `getClassType` in interface `Spy`
  Overrides:
    `getClassType` in class `PreparedStatementSpy`

### getDate

    public Date getDate(int parameterIndex)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object.

  Specified by:
    `getDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setDate(java.lang.String, java.sql.Date)`

### getDate

    public Date getDate(int parameterIndex,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `cal` - the `Calendar` object the driver will use to construct the date
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setDate(java.lang.String, java.sql.Date)`

### getRef

    public Ref getRef(String parameterName)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.

  Specified by:
    `getRef` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value as a `Ref` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getTime

    public Time getTime(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object.

  Specified by:
    `getTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTime(java.lang.String, java.sql.Time)`

### setTime

    public void setTime(String parameterName,
                        Time x)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

  Specified by:
    `setTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getTime(int)`

### getBlob

    public Blob getBlob(int i)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `BLOB` parameter as a `Blob` object in the Java programming language.

  Specified by:
    `getBlob` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value as a `Blob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getClob

    public Clob getClob(int i)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `CLOB` parameter as a `Clob` object in the Java programming language.

  Specified by:
    `getClob` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value as a `Clob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getArray

    public Array getArray(int i)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `ARRAY` parameter as an `Array` object in the Java programming language.

  Specified by:
    `getArray` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value as an `Array` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getBytes

    public byte[] getBytes(int parameterIndex)
                    throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.

  Specified by:
    `getBytes` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setBytes(java.lang.String, byte[])`

### getDouble

    public double getDouble(int parameterIndex)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `DOUBLE` parameter as a `double` in the Java programming language.

  Specified by:
    `getDouble` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setDouble(java.lang.String, double)`

### getInt

    public int getInt(int parameterIndex)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `INTEGER` parameter as an `int` in the Java programming language.

  Specified by:
    `getInt` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setInt(java.lang.String, int)`

### wasNull

    public boolean wasNull()
                    throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves whether the last OUT parameter read had the value of SQL `NULL`. Note that this method should be called only after calling a getter method; otherwise, there is no value to use in determining whether it is `null` or not.

  Specified by:
    `wasNull` in interface `CallableStatement`
  Throws:
    `SQLException`
  Returns:
    `true` if the last parameter read was SQL `NULL`; `false` otherwise

### getTime

    public Time getTime(int parameterIndex)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object.

  Specified by:
    `getTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTime(java.lang.String, java.sql.Time)`

### getTime

    public Time getTime(int parameterIndex,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `cal` - the `Calendar` object the driver will use to construct the time
  Returns:
    the parameter value; if the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTime(java.lang.String, java.sql.Time)`

### getTimestamp

    public Timestamp getTimestamp(String parameterName)
                           throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.

  Specified by:
    `getTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTimestamp(java.lang.String, java.sql.Timestamp)`

### setTimestamp

    public void setTimestamp(String parameterName,
                             Timestamp x)
                      throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

  Specified by:
    `setTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getTimestamp(int)`

### getString

    public String getString(int parameterIndex)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.

  For the fixed-length type JDBC `CHAR`, the `String` object returned has exactly the same value the JDBC `CHAR` value had in the database, including any padding added by the database.

  Specified by:
    `getString` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setString(java.lang.String, java.lang.String)`

### registerOutParameter

    public void registerOutParameter(int parameterIndex,
                                     int sqlType)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the OUT parameter in ordinal position `parameterIndex` to the JDBC type `sqlType`. All OUT parameters must be registered before a stored procedure is executed.

  The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

  If the JDBC type expected to be returned to this output parameter is specific to this particular database, `sqlType` should be `java.sql.Types.OTHER`. The method `CallableStatement.getObject(int)` retrieves the value.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `sqlType` - the JDBC type code defined by `java.sql.Types`. If the parameter is of JDBC type `NUMERIC` or `DECIMAL`, the version of `registerOutParameter` that accepts a scale value should be used.
  See Also:
    `Types`

### registerOutParameter

    public void registerOutParameter(int parameterIndex,
                                     int sqlType,
                                     int scale)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the parameter in ordinal position `parameterIndex` to be of JDBC type `sqlType`. This method must be called before a stored procedure is executed.

  The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

  This version of `registerOutParameter` should be used when the parameter is of JDBC type `NUMERIC` or `DECIMAL`.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `sqlType` - the SQL type code defined by `java.sql.Types`.
    `scale` - the desired number of digits to the right of the decimal point. It must be greater than or equal to zero.
  See Also:
    `Types`

### registerOutParameter

    public void registerOutParameter(int paramIndex,
                                     int sqlType,
                                     String typeName)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the designated output parameter. This version of the method `registerOutParameter` should be used for a user-defined or `REF` output parameter. Examples of user-defined types include: `STRUCT`, `DISTINCT`, `JAVA_OBJECT`, and named array types. Before executing a stored procedure call, you must explicitly call `registerOutParameter` to register the type from `java.sql.Types` for each OUT parameter. For a user-defined parameter, the fully-qualified SQL type name of the parameter should also be given, while a `REF` parameter requires that the fully-qualified type name of the referenced type be given. A JDBC driver that does not need the type code and type name information may ignore it. To be portable, however, applications should always provide these values for user-defined and `REF` parameters. Although it is intended for user-defined and `REF` parameters, this method may be used to register a parameter of any JDBC type. If the parameter does not have a user-defined or `REF` type, the typeName parameter is ignored.

  Note: When reading the value of an out parameter, you must use the getter method whose Java type corresponds to the parameter's registered SQL type.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `paramIndex` - the first parameter is 1, the second is 2,...
    `sqlType` - a value from `Types`
    `typeName` - the fully-qualified name of an SQL structured type
  See Also:
    `Types`

### getByte

    public byte getByte(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `TINYINT` parameter as a `byte` in the Java programming language.

  Specified by:
    `getByte` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setByte(java.lang.String, byte)`

### getDouble

    public double getDouble(String parameterName)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `DOUBLE` parameter as a `double` in the Java programming language.

  Specified by:
    `getDouble` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setDouble(java.lang.String, double)`

### getFloat

    public float getFloat(String parameterName)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `FLOAT` parameter as a `float` in the Java programming language.

  Specified by:
    `getFloat` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setFloat(java.lang.String, float)`

### getInt

    public int getInt(String parameterName)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `INTEGER` parameter as an `int` in the Java programming language.

  Specified by:
    `getInt` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setInt(java.lang.String, int)`

### getLong

    public long getLong(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `BIGINT` parameter as a `long` in the Java programming language.

  Specified by:
    `getLong` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setLong(java.lang.String, long)`

### getShort

    public short getShort(String parameterName)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `SMALLINT` parameter as a `short` in the Java programming language.

  Specified by:
    `getShort` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setShort(java.lang.String, short)`

### getBoolean

    public boolean getBoolean(String parameterName)
                       throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `BIT` parameter as a `boolean` in the Java programming language.

  Specified by:
    `getBoolean` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `false`.
  See Also:
    `CallableStatement.setBoolean(java.lang.String, boolean)`

### getBytes

    public byte[] getBytes(String parameterName)
                    throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.

  Specified by:
    `getBytes` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setBytes(java.lang.String, byte[])`

### setByte

    public void setByte(String parameterName,
                        byte x)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

  Specified by:
    `setByte` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getByte(int)`

### setDouble

    public void setDouble(String parameterName,
                          double x)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

  Specified by:
    `setDouble` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getDouble(int)`

### setFloat

    public void setFloat(String parameterName,
                         float x)
                  throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.

  Specified by:
    `setFloat` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getFloat(int)`

### registerOutParameter

    public void registerOutParameter(String parameterName,
                                     int sqlType)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the OUT parameter named `parameterName` to the JDBC type `sqlType`. All OUT parameters must be registered before a stored procedure is executed.

  The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

  If the JDBC type expected to be returned to this output parameter is specific to this particular database, `sqlType` should be `java.sql.Types.OTHER`. The method `CallableStatement.getObject(int)` retrieves the value.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `sqlType` - the JDBC type code defined by `java.sql.Types`. If the parameter is of JDBC type `NUMERIC` or `DECIMAL`, the version of `registerOutParameter` that accepts a scale value should be used.
  See Also:
    `Types`

### setInt

    public void setInt(String parameterName,
                       int x)
                throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

  Specified by:
    `setInt` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getInt(int)`

### setNull

    public void setNull(String parameterName,
                        int sqlType)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to SQL `NULL`.

  Note: You must specify the parameter's SQL type.

  Specified by:
    `setNull` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `sqlType` - the SQL type code defined in `java.sql.Types`

### registerOutParameter

    public void registerOutParameter(String parameterName,
                                     int sqlType,
                                     int scale)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the parameter named `parameterName` to be of JDBC type `sqlType`. This method must be called before a stored procedure is executed.

  The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

  This version of `registerOutParameter` should be used when the parameter is of JDBC type `NUMERIC` or `DECIMAL`.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `sqlType` - SQL type code defined by `java.sql.Types`.
    `scale` - the desired number of digits to the right of the decimal point. It must be greater than or equal to zero.
  See Also:
    `Types`

### setLong

    public void setLong(String parameterName,
                        long x)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

  Specified by:
    `setLong` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getLong(int)`

### setShort

    public void setShort(String parameterName,
                         short x)
                  throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

  Specified by:
    `setShort` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getShort(int)`

### setBoolean

    public void setBoolean(String parameterName,
                           boolean x)
                    throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` value when it sends it to the database.

  Specified by:
    `setBoolean` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getBoolean(int)`

### setBytes

    public void setBytes(String parameterName,
                         byte[] x)
                  throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

  Specified by:
    `setBytes` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getBytes(int)`

### getBoolean

    public boolean getBoolean(int parameterIndex)
                       throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `BIT` parameter as a `boolean` in the Java programming language.

  Specified by:
    `getBoolean` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `false`.
  See Also:
    `CallableStatement.setBoolean(java.lang.String, boolean)`

### getTimestamp

    public Timestamp getTimestamp(int parameterIndex)
                           throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.

  Specified by:
    `getTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTimestamp(java.lang.String, java.sql.Timestamp)`

### setAsciiStream

    public void setAsciiStream(String parameterName,
                               InputStream x,
                               int length)
                        throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setAsciiStream` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the Java input stream that contains the ASCII parameter value
    `length` - the number of bytes in the stream

### setBinaryStream

    public void setBinaryStream(String parameterName,
                                InputStream x,
                                int length)
                         throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setBinaryStream` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the java input stream which contains the binary parameter value
    `length` - the number of bytes in the stream

### setCharacterStream

    public void setCharacterStream(String parameterName,
                                   Reader reader,
                                   int length)
                            throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setCharacterStream` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `reader` - the `java.io.Reader` object that contains the UNICODE data used as the designated parameter
    `length` - the number of characters in the stream

### getObject

    public Object getObject(String parameterName)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a parameter as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`.

  This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

  Specified by:
    `getObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    A `java.lang.Object` holding the OUT parameter value.
  See Also:
    `Types`, `CallableStatement.setObject(java.lang.String, java.lang.Object, int, int)`

### setObject

    public void setObject(String parameterName,
                          Object x)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the value of the designated parameter with the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

  The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

  Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

  Specified by:
    `setObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the object containing the input parameter value
  See Also:
    `CallableStatement.getObject(int)`

### setObject

    public void setObject(String parameterName,
                          Object x,
                          int targetSqlType)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

  Specified by:
    `setObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
  See Also:
    `CallableStatement.getObject(int)`

### setObject

    public void setObject(String parameterName,
                          Object x,
                          int targetSqlType,
                          int scale)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

  The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  Note that this method may be used to pass datatabase- specific abstract data types.

  Specified by:
    `setObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
    `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.
  See Also:
    `Types`, `CallableStatement.getObject(int)`

### getTimestamp

    public Timestamp getTimestamp(int parameterIndex,
                                  Calendar cal)
                           throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `cal` - the `Calendar` object the driver will use to construct the timestamp
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTimestamp(java.lang.String, java.sql.Timestamp)`

### getObject

    public Object getObject(String parameterName,
                            Map map)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Returns an object representing the value of OUT parameter `i` and uses `map` for the custom mapping of the parameter value.

  This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

  Specified by:
    `getObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `map` - the mapping from SQL type names to Java classes
  Returns:
    a `java.lang.Object` holding the OUT parameter value
  See Also:
    `CallableStatement.setObject(java.lang.String, java.lang.Object, int, int)`

### getDate

    public Date getDate(String parameterName,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `cal` - the `Calendar` object the driver will use to construct the date
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setDate(java.lang.String, java.sql.Date)`

### getTime

    public Time getTime(String parameterName,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `cal` - the `Calendar` object the driver will use to construct the time
  Returns:
    the parameter value; if the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTime(java.lang.String, java.sql.Time)`

### getTimestamp

    public Timestamp getTimestamp(String parameterName,
                                  Calendar cal)
                           throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

  Specified by:
    `getTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `cal` - the `Calendar` object the driver will use to construct the timestamp
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setTimestamp(java.lang.String, java.sql.Timestamp)`

### setDate

    public void setDate(String parameterName,
                        Date x,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the date
  See Also:
    `CallableStatement.getDate(int)`

### setTime

    public void setTime(String parameterName,
                        Time x,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTime` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the time
  See Also:
    `CallableStatement.getTime(int)`

### setTimestamp

    public void setTimestamp(String parameterName,
                             Timestamp x,
                             Calendar cal)
                      throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTimestamp` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the timestamp
  See Also:
    `CallableStatement.getTimestamp(int)`

### getShort

    public short getShort(int parameterIndex)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `SMALLINT` parameter as a `short` in the Java programming language.

  Specified by:
    `getShort` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setShort(java.lang.String, short)`

### getLong

    public long getLong(int parameterIndex)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `BIGINT` parameter as a `long` in the Java programming language.

  Specified by:
    `getLong` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setLong(java.lang.String, long)`

### getFloat

    public float getFloat(int parameterIndex)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `FLOAT` parameter as a `float` in the Java programming language.

  Specified by:
    `getFloat` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setFloat(java.lang.String, float)`

### getRef

    public Ref getRef(int i)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.

  Specified by:
    `getRef` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value as a `Ref` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getBigDecimal

    public BigDecimal getBigDecimal(int parameterIndex,
                                    int scale)
                             throws SQLException

  Deprecated.

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with scale digits to the right of the decimal point.

  Specified by:
    `getBigDecimal` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
    `scale` - the number of digits to the right of the decimal point
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setBigDecimal(java.lang.String, java.math.BigDecimal)`

### getURL

    public URL getURL(int parameterIndex)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `DATALINK` parameter as a `java.net.URL` object.

  Specified by:
    `getURL` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2,...
  Returns:
    a `java.net.URL` object that represents the JDBC `DATALINK` value used as the designated parameter
  See Also:
    `CallableStatement.setURL(java.lang.String, java.net.URL)`

### getBigDecimal

    public BigDecimal getBigDecimal(int parameterIndex)
                             throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.

  Specified by:
    `getBigDecimal` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value in full precision. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setBigDecimal(java.lang.String, java.math.BigDecimal)`

### getByte

    public byte getByte(int parameterIndex)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated JDBC `TINYINT` parameter as a `byte` in the Java programming language.

  Specified by:
    `getByte` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `0`.
  See Also:
    `CallableStatement.setByte(java.lang.String, byte)`

### getObject

    public Object getObject(int parameterIndex)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of the designated parameter as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`.

  This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

  Specified by:
    `getObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, and so on
  Returns:
    A `java.lang.Object` holding the OUT parameter value
  See Also:
    `Types`, `CallableStatement.setObject(java.lang.String, java.lang.Object, int, int)`

### getObject

    public Object getObject(int i,
                            Map map)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Returns an object representing the value of OUT parameter `i` and uses `map` for the custom mapping of the parameter value.

  This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

  Specified by:
    `getObject` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, and so on
    `map` - the mapping from SQL type names to Java classes
  Returns:
    a `java.lang.Object` holding the OUT parameter value
  See Also:
    `CallableStatement.setObject(java.lang.String, java.lang.Object, int, int)`

### getString

    public String getString(String parameterName)
                     throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.

  For the fixed-length type JDBC `CHAR`, the `String` object returned has exactly the same value the JDBC `CHAR` value had in the database, including any padding added by the database.

  Specified by:
    `getString` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setString(java.lang.String, java.lang.String)`

### registerOutParameter

    public void registerOutParameter(String parameterName,
                                     int sqlType,
                                     String typeName)
                              throws SQLException

  Description copied from interface: `CallableStatement`
  Registers the designated output parameter. This version of the method `registerOutParameter` should be used for a user-named or REF output parameter. Examples of user-named types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types. Before executing a stored procedure call, you must explicitly call `registerOutParameter` to register the type from `java.sql.Types` for each OUT parameter. For a user-named parameter the fully-qualified SQL type name of the parameter should also be given, while a REF parameter requires that the fully-qualified type name of the referenced type be given. A JDBC driver that does not need the type code and type name information may ignore it. To be portable, however, applications should always provide these values for user-named and REF parameters. Although it is intended for user-named and REF parameters, this method may be used to register a parameter of any JDBC type. If the parameter does not have a user-named or REF type, the typeName parameter is ignored.

  Note: When reading the value of an out parameter, you must use the `getXXX` method whose Java type XXX corresponds to the parameter's registered SQL type.

  Specified by:
    `registerOutParameter` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `sqlType` - a value from `Types`
    `typeName` - the fully-qualified name of an SQL structured type
  See Also:
    `Types`

### setNull

    public void setNull(String parameterName,
                        int sqlType,
                        String typeName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

  Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

  Specified by:
    `setNull` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `sqlType` - a value from `java.sql.Types`
    `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or SQL `REF` value

### setString

    public void setString(String parameterName,
                          String x)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

  Specified by:
    `setString` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getString(int)`

### getBigDecimal

    public BigDecimal getBigDecimal(String parameterName)
                             throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.

  Specified by:
    `getBigDecimal` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value in full precision. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setBigDecimal(java.lang.String, java.math.BigDecimal)`

### setBigDecimal

    public void setBigDecimal(String parameterName,
                              BigDecimal x)
                       throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

  Specified by:
    `setBigDecimal` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getBigDecimal(int, int)`

### getURL

    public URL getURL(String parameterName)
               throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `DATALINK` parameter as a `java.net.URL` object.

  Specified by:
    `getURL` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value as a `java.net.URL` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
  See Also:
    `CallableStatement.setURL(java.lang.String, java.net.URL)`

### setURL

    public void setURL(String parameterName,
                       URL val)
                throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.net.URL` object. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

  Specified by:
    `setURL` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `val` - the parameter value
  See Also:
    `CallableStatement.getURL(int)`

### getArray

    public Array getArray(String parameterName)
                   throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `ARRAY` parameter as an `Array` object in the Java programming language.

  Specified by:
    `getArray` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value as an `Array` object in Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getBlob

    public Blob getBlob(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `BLOB` parameter as a `Blob` object in the Java programming language.

  Specified by:
    `getBlob` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value as a `Blob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getClob

    public Clob getClob(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `CLOB` parameter as a `Clob` object in the Java programming language.

  Specified by:
    `getClob` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value as a `Clob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.

### getDate

    public Date getDate(String parameterName)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object.

  Specified by:
    `getDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
  Returns:
    the parameter value. If the value is SQL `NULL`, the result is `null`.
  See Also:
    `CallableStatement.setDate(java.lang.String, java.sql.Date)`

### setDate

    public void setDate(String parameterName,
                        Date x)
                 throws SQLException

  Description copied from interface: `CallableStatement`
  Sets the designated parameter to the given `java.sql.Date` value. The driver converts this to an SQL `DATE` value when it sends it to the database.

  Specified by:
    `setDate` in interface `CallableStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterName` - the name of the parameter
    `x` - the parameter value
  See Also:
    `CallableStatement.getDate(int)`

Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD